using System;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Threading.Tasks;
using WingInterfaceLibrary.DTO.User;
using WingInterfaceLibrary.Enum;
using WingInterfaceLibrary.Internal.Interface;
using WingInterfaceLibrary.Internal.Request;
using WingServerCommon.Config;
using WingServerCommon.Log;

namespace WingUserModule.Common
{

    /// <summary>
    /// 讨论消息实体
    /// </summary>
    public class DiscusssInfo
    {
        /// <summary>
        /// name
        /// </summary>
        /// <value></value>
        public string Name { get; set; }

        /// <summary>
        /// 头像
        /// </summary>
        /// <value></value>
        public string HeadImage { get; set; }

        /// <summary>
        /// 内容
        /// </summary>
        /// <value></value>
        public string Content { get; set; }

        /// <summary>
        /// 发送时间
        /// </summary>
        /// <value></value>
        public DateTime SendTime { get; set; }
    }

    // public class DiscussManager
    // {


    //     public static IList<string> ExpireOrErrorScanCodes = new List<string>();

    //     private IMasterInteractionCenterService _masterInteractionCenterService;

    //     private ConcurrentDictionary<string, List<DiscusssInfo>> _discusssDictoinary = new ConcurrentDictionary<string, List<DiscusssInfo>>();

    //     public DiscussManager(IMasterInteractionCenterService masterInteractionCenterService)
    //     {
    //         _masterInteractionCenterService = masterInteractionCenterService;
    //     }

    //     public async Task<bool> AddDiscusssInfo(string roomId,DiscusssInfo discusssInfo, int syncType = 0)
    //     {

    //         _discusssDictoinary.TryAdd(userScanInfo.ScanCode, userScanInfo, (k, v) =>
    //         {
    //             return userScanInfo;
    //         });
    //         //同步其他服务器
    //         if (syncType == 0)
    //         {
    //             await SyncToMasterAsync(userScanInfo);
    //         }
    //         return true;
    //     }

       
    //     /// <summary>
    //     /// 获取
    //     /// </summary>
    //     /// <param name="key"></param>
    //     /// <returns></returns>
    //     public UserScanInfo Get(string key)
    //     {
    //         if (_userInfos.TryGetValue(key, out UserScanInfo obj))
    //         {
    //             return obj;
    //         }
    //         return null;
    //     }



    //     /// <summary>
    //     /// 同步内存给主服务器
    //     /// </summary>
    //     /// <param name="userScanInfo"></param>
    //     /// <returns></returns>
    //     private async Task SyncToMasterAsync(UserScanInfo userScanInfo)
    //     {
    //         try
    //         {
    //             if (ConfigurationManager.IsDistributed)
    //             {
    //                 var syncRequest = new SyncReceiveServiceDataRequest
    //                 {
    //                     SyncService = SyncServiceEnum.ScanLogin,
    //                     SourceUrl = EnvironmentConfigManager.GetParammeter<StringParameter>("Gateway", "Domains").Value,
    //                     ServiceDataJson = Newtonsoft.Json.JsonConvert.SerializeObject(userScanInfo),
    //                 };
    //                 await _masterInteractionCenterService.SyncReceiveSlaveServiceDataAsync(syncRequest);
    //             }
    //         }
    //         catch (Exception ex)
    //         {
    //             Logger.WriteLineWarn($"ScanLoginManager SyncToMasterAsync err, userScanInfo:{Newtonsoft.Json.JsonConvert.SerializeObject(userScanInfo)}, err: {ex}");
    //         }
    //     }
    // }

}